/*******************************************************************\

Module: Extension Classes

Author: CM Wintersteiger

\*******************************************************************/

#ifndef QBV_EXTENSIONS_H_
#define QBV_EXTENSIONS_H_

#include <vector>

#include "literal.h"

class extension {
public:
  unsigned line_no;
  Literal new_var;
  
  extension(void) : new_var(0,false) {}
};

class and_extension : public extension {
public:
    std::vector<Literal> literals;
};

class ite_extension : public extension {
public:    
    Literal condition;
    Literal true_branch;
    Literal false_branch;
    
    ite_extension(void) : 
      condition(0,false), true_branch(0,false), false_branch(0,false) {}
};

#endif
