/*******************************************************************\

Module: Exceptions 

Author: CM Wintersteiger

\*******************************************************************/

#ifndef EXCEPTION_H_
#define EXCEPTION_H_

class Exception {
  private:
    std::string msg;
  public:
    Exception(const std::string &emsg) { this->msg = emsg; }
    Exception(const char *e) { this->msg = e; }
    std::string &message( void ) { return msg; }
};

#endif
